const { error } = require("console");

var client;

init();

async function init() {
  client = await app.initialized();
  client.events.on('app.activated', renderText);

}
async function renderText() {
  const textElement = document.getElementById('apptext');
  const contactData = await client.data.get('contact');
  const {
    contact: { name }
  } = contactData;

  textElement.innerHTML = `Ticket is created by ${name}`;
}

async function push(){

  client = await app.initialized();

  var headers = {"Authorization": "Basic <%= encode(iparam.api_key) %>"};
  var options = { headers: headers };
  var url= "https://<%= iparam.domain %>.freshdesk.com/api/v2/tickets";
 
  client.request.get(url, options)
  .then (
  function(data) {
    let content= JSON.parse(data.response);
   
    content.map((values)=>{
      let status =values.status;
      let type =values.type;
      let ID =values.id;
      let SUB =values.subject;
      
     
      if(status!==5&&type=="Refund"){
       getConversation(ID,SUB);
      }
    })   
   

  },
  function(error) {
    console.log(error);
  });



}

async function getConversation (ID,SUB){
  client = await app.initialized();

  var headers = {"Authorization": "Basic <%= encode(iparam.api_key) %>"};
  var options = { headers: headers };
  var url= `https://<%= iparam.domain %>.freshdesk.com/api/v2/tickets/${ID}/conversations`;
  
 
  client.request.get(url, options)
  .then (
  function(data) {
    let content= JSON.parse(data.response);
   console.log(content)
    content.map((values)=>{
      let body =values.body;
     pushToGit(SUB,body)
    })   
   

  },
  function(error) {
    console.log(error);
  });
}

async function pushToGit(sub,body){

   const  issue = {
    title: sub,
    body: body
};

   let raw=JSON.stringify(issue);

  let headers = {"Authorization": "Token <%= iparam.git_api_key %> ",
  
  'User-Agent': 'Freshdesk Sample User Agent',
 
};
  let options = {
    method:"POST",
    headers: headers,
    body:raw,
    
 
    }
   
  const url = `https://api.github.com/repos/<%= iparam.GitUserName %>/<%= iparam.GitRepoName %>/issues`;
  
  client.request.get(url, options)
  .then (
  function(data) {
    let content= JSON.parse(data);
    
   console.log(content)   
   

  },
  function(error) {
    console.log(error);
  })
  



 //console.log(url)

//  client.iparams.get('GitRepoName','GitUserName').then(function (iparam) {
//   client.request.get(`https://api.github.com/repos/Arokiya-Kithiyon/gitissue/issues`,options)
//     .then(function (res) {
//       try {
//         data = JSON.parse(res.response);
       
//       } catch (error) {
//         console.error("Error while attempting to show issue", error);
//       }
//     })
//     .catch(function (error) {
//       console.error("error", error);
//     });
// });



 // json: {
    //   name: 'web',
    //   active: true,
    //   events: [
    //     'issues'
    //   ],
    //   config: {
        
    //     content_type: 'json'
    //   }


 /// isOAuth: true
   // let user = jQuery("input[name=username]").val().trim();
  // let repo = jQuery("input[name=reponame]").val().trim();
  // const token = "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";
//  let options ={
//   method:"POST",
//   headers : {
//     "Authorization": `Token ${token} `,
//     "Accept": "application/vnd.github+json"
// },
// body:raw
// }
 
//   await fetch(url,options)
//   .then(Response=>Response.json())
//   .then(result=>{
//     console.log(result)
//   })
//    .catch(er=>{
//     console.log(er)
//    });

}



